;	===============================================================
;	FORMST.CPY - Format string equates, structures, and macros
;	===============================================================
;	Copyright 1995-1999 Evolution Computing
;	All rights reserved
;	Written by Mike Riddle 4-26-95
;	===============================================================

FormSt		proto	stdcall,pPattern:dword, \
			pVList:dword,pBase:dword,pDest:dword

SetFormStDest	proto	stdcall,id:dword,pText:dword
PadLMargin	proto	stdcall,NrChrs:dword,CValue:dword
SetDecP		proto	stdcall,nDecP:dword
SetDFmt		proto	stdcall,nDFmt:dword
SetAltDFmt	proto	stdcall,nDFmt:dword
SetAFmt		proto	stdcall,nAFmt:dword
SetFRnd		proto	stdcall,nFRnd:dword
SetFSUnitV	proto	stdcall,NewUnitV:real8

;	===============================================================

FV_ASM		equ	0	;pVList follows dword ptr to pPattern data
FV_NONE		equ	-1	;no vlist needed,pPattern is pat stg adr

FT_Ptr	equ	80h		;var contains dword pointer to data or rsc id
FT_EBX	equ	20h		;var is offset from EBX on entry to FORMST
FT_Pad0	equ	40h		;pad fixed-length field with 0's
;
;	if above bits not set, var is actual data or resource id
;
FT_MASK	equ	0000001Fh	;ask for data type code only

FT_Stg		equ	0	;ASCIIZ string
FT_UDec1	equ	1	;unsigned byte
FT_UDec2	equ	2	;unsigned word
FT_UDec4	equ	3	;unsigned dword
FT_Dec2		equ	4	;signed word
FT_Dec4		equ	5	;signed dword
FT_Hex1		equ	6	;hex byte
FT_Hex2		equ	7	;hex word
FT_Hex4		equ	8	;hex dword
FT_Real4	equ	9	;dword real
FT_Real8	equ	10	;qword real
FT_2dC4		equ	11	;2d dword X,Y dword coordinate
FT_2dC8		equ	12	;2d dword X,Y qword coordinate
FT_3dC4		equ	13	;3d dword X,Y,Z dword coordinate
FT_3dC8		equ	14	;3d dword X,Y,Z qword coordinate
FT_Dist4	equ	15	;dword real distance
FT_Dist8	equ	16	;qword real distance
FT_Brng4	equ	17	;dword real bearing angle
FT_AngW4	equ	18	;dword real angle width
FT_Brng8	equ	19	;qword real bearing angle
FT_AngW8	equ	20	;qword real angle width
FT_Area4	equ	21	;dword real area
FT_Area8	equ	22	;qword real area
;
FT_AltDist4	equ	23	;alt Dist4 format
;
ItemFmt		STRUC
vadr		dword	0	;var adrs/RSCID
tcode		sbyte	0	;type code
jcode		sbyte	0	;justification code
fwid		sbyte	0	;field width
ndecp		sbyte	FDP_User ;# decimal places
ItemFmt		ENDS

FJ_Var		equ	0	;variable width field
FJ_Left		equ	1	;left justified
FJ_Cen		equ	2	;center justified
FJ_Right	equ	4	;right justified

FDP_User	equ	0FFh	;current user-sel # dec place
FDP_Dim		equ	0FEh	;# dec pl by SetDimDecP

;	standard destinations

FD_MsgBox	equ	1	;Message Box (generic, no icons)
FD_InfoBox	equ	2	;Info icon message box
FD_WarnBox	equ	3	;Warning (! icon) message box
FD_ErrorBox	equ	4	;Critical error message box
FD_QuestBox	equ	5	;Question (yes/no) message box
FD_CancelBox	equ	6	;Yes/No/Cancel message box
FD_RetryBox	equ	7	;Retry/Cancel message box
FD_Prompt	equ	8	;prompt bar
FD_TxWin	equ	9	;current text window
FD_DlgTitle	equ	10	;Dialog Box Init: Dlg Box Title
FD_Status	equ	11	;status bar (tracking) message

FD_MaxStd	equ	16	;for comparison to resource ids

FD_BTitle	equ	32	;flag for dlg boxes, pBase is adrs
;				;of title string for msgbox.

