;	===============================================================
;	Header.CPY - Header InfoBlock
;	===============================================================
;	Copyright 1999 Evolution Computing
;	All rights reserved
;	Written by Mike Riddle 30-July-1999
;	===============================================================

SetCStuff	proto	stdcall,pEnt:dword
CopyCStuff	proto	stdcall,pFrom:dword,pTo:dword
CopyColor	proto	stdcall,pFrom:dword,pTo:dword
SetNewTag	proto	stdcall,pEnt:dword
GetCurColor	proto	stdcall
SetCurColor	proto	stdcall,ColorV:dword
GetBkgndColor	proto	stdcall,hDWin:dword
SetBkgndColor	proto	stdcall,ColorV:dword
SwitchMainDL	proto	stdcall,hDList:dword
SwitchRefDL	proto	stdcall,hDList:dword
GetAtchStatus	proto	stdcall
SetAtchStatus	proto	stdcall,v:dword

IB_HDR		equ	0
IB_HDR_VER	equ	4
DB_VER		equ	0

HDR		struc
ERLen		dword	sizeof(HDR)
EType		db	ET_IB		;record = infoblock
IType		db	IB_HDR		;type of infoblock
Ver		db	IB_HDR_VER	;IB version number
DBVer		db	DB_VER		;database format version
;
CurColor	dword	01000000h	;current outline color
BkgndColor	dword	0100001Eh	;drawing background color
rsvd		dword	20 dup (0)
SWFlags		dword	0		;switch status flags
LastTag		dword	0		;last tag number
;
UnitV		real8	1.0		;inches per drawing unit
AngFmt		db	0		;angle display format:
;					; bit 4 set ANGW is dms
;					; bit 2 set BRNG is surveyors
;					; bit 1 set BRNG is dms
;					; else decimal degrees
DistFmt		db	0		;distance format
DecP		db	5		;decimal places
FRnd		db	4		;fractions to nearest (power of 2)
;
CurThick	db	0		;current pen thickness 0->25.4 mm
CurColor2	dword	01000000h	;current fill color
CurWidth	real4	0.0		;current edge width
SplRes		db	8		;current spline resolution
;
PTFmt		db	5		;5=mm 1=inches, PThick display fmt
TkFmt		db	0		;0=abs 1=rel 2=cyl 3=sph 4=none
fill1		db	21 dup (0)
TH1		real4	0.15		;4 most recent text heights
TH2		real4	0.2
TH3		real4	0.25
TH4		real4	0.5
;
CurPT		real4	0.0		;current pen thickness (match CurThick)
PT1		real4	0.007874015	;4 most recent pen thicknesses
PT2		real4	0.011811023
PT3		real4	0.019685039
PT4		real4	0.027559054
;
LW1		real4	0.1		;4 most recent line widths
LW2		real4	0.25
LW3		real4	0.5
LW4		real4	1.0
;

ArwSty		ASty	<>		;current arrow style
WallWidth	real4	6.0		;current wall width
ReservedV	dword	0,0
fill		db	(512-223) dup (0)
HDR		ends

;	Values for SWFlags are:

SW_Grid		equ	1
SW_Snap		equ	2
SW_CSnap	equ	4
SW_Ortho	equ	8
SW_Attach	equ	10h
SW_Unlock	equ	20h
SW_Depth	equ	40h
SW_SheetAH	equ	80h

;	===============================================================
